<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAvailabilityPeriod ArrayType
 * @subpackage Arrays
 */
class ArrayOfAvailabilityPeriod extends AbstractStructArrayBase
{
    /**
     * The AvailabilityPeriod
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AvailabilityPeriod[]
     */
    public $AvailabilityPeriod;
    /**
     * Constructor method for ArrayOfAvailabilityPeriod
     * @uses ArrayOfAvailabilityPeriod::setAvailabilityPeriod()
     * @param \StructType\AvailabilityPeriod[] $availabilityPeriod
     */
    public function __construct(array $availabilityPeriod = array())
    {
        $this
            ->setAvailabilityPeriod($availabilityPeriod);
    }
    /**
     * Get AvailabilityPeriod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AvailabilityPeriod[]|null
     */
    public function getAvailabilityPeriod()
    {
        return isset($this->AvailabilityPeriod) ? $this->AvailabilityPeriod : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAvailabilityPeriod method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAvailabilityPeriod method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAvailabilityPeriodForArrayConstraintsFromSetAvailabilityPeriod(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAvailabilityPeriodAvailabilityPeriodItem) {
            // validation for constraint: itemType
            if (!$arrayOfAvailabilityPeriodAvailabilityPeriodItem instanceof \StructType\AvailabilityPeriod) {
                $invalidValues[] = is_object($arrayOfAvailabilityPeriodAvailabilityPeriodItem) ? get_class($arrayOfAvailabilityPeriodAvailabilityPeriodItem) : sprintf('%s(%s)', gettype($arrayOfAvailabilityPeriodAvailabilityPeriodItem), var_export($arrayOfAvailabilityPeriodAvailabilityPeriodItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AvailabilityPeriod property can only contain items of type \StructType\AvailabilityPeriod, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AvailabilityPeriod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AvailabilityPeriod[] $availabilityPeriod
     * @return \ArrayType\ArrayOfAvailabilityPeriod
     */
    public function setAvailabilityPeriod(array $availabilityPeriod = array())
    {
        // validation for constraint: array
        if ('' !== ($availabilityPeriodArrayErrorMessage = self::validateAvailabilityPeriodForArrayConstraintsFromSetAvailabilityPeriod($availabilityPeriod))) {
            throw new \InvalidArgumentException($availabilityPeriodArrayErrorMessage, __LINE__);
        }
        if (is_null($availabilityPeriod) || (is_array($availabilityPeriod) && empty($availabilityPeriod))) {
            unset($this->AvailabilityPeriod);
        } else {
            $this->AvailabilityPeriod = $availabilityPeriod;
        }
        return $this;
    }
    /**
     * Add item to AvailabilityPeriod value
     * @throws \InvalidArgumentException
     * @param \StructType\AvailabilityPeriod $item
     * @return \ArrayType\ArrayOfAvailabilityPeriod
     */
    public function addToAvailabilityPeriod(\StructType\AvailabilityPeriod $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AvailabilityPeriod) {
            throw new \InvalidArgumentException(sprintf('The AvailabilityPeriod property can only contain items of type \StructType\AvailabilityPeriod, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AvailabilityPeriod[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AvailabilityPeriod|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AvailabilityPeriod|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AvailabilityPeriod|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AvailabilityPeriod|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AvailabilityPeriod|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AvailabilityPeriod
     */
    public function getAttributeName()
    {
        return 'AvailabilityPeriod';
    }
}
