<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEstablishmentUpdatedOn ArrayType
 * @subpackage Arrays
 */
class ArrayOfEstablishmentUpdatedOn extends AbstractStructArrayBase
{
    /**
     * The EstablishmentUpdatedOn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EstablishmentUpdatedOn[]
     */
    public $EstablishmentUpdatedOn;
    /**
     * Constructor method for ArrayOfEstablishmentUpdatedOn
     * @uses ArrayOfEstablishmentUpdatedOn::setEstablishmentUpdatedOn()
     * @param \StructType\EstablishmentUpdatedOn[] $establishmentUpdatedOn
     */
    public function __construct(array $establishmentUpdatedOn = array())
    {
        $this
            ->setEstablishmentUpdatedOn($establishmentUpdatedOn);
    }
    /**
     * Get EstablishmentUpdatedOn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EstablishmentUpdatedOn[]|null
     */
    public function getEstablishmentUpdatedOn()
    {
        return isset($this->EstablishmentUpdatedOn) ? $this->EstablishmentUpdatedOn : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEstablishmentUpdatedOn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEstablishmentUpdatedOn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEstablishmentUpdatedOnForArrayConstraintsFromSetEstablishmentUpdatedOn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEstablishmentUpdatedOnEstablishmentUpdatedOnItem) {
            // validation for constraint: itemType
            if (!$arrayOfEstablishmentUpdatedOnEstablishmentUpdatedOnItem instanceof \StructType\EstablishmentUpdatedOn) {
                $invalidValues[] = is_object($arrayOfEstablishmentUpdatedOnEstablishmentUpdatedOnItem) ? get_class($arrayOfEstablishmentUpdatedOnEstablishmentUpdatedOnItem) : sprintf('%s(%s)', gettype($arrayOfEstablishmentUpdatedOnEstablishmentUpdatedOnItem), var_export($arrayOfEstablishmentUpdatedOnEstablishmentUpdatedOnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EstablishmentUpdatedOn property can only contain items of type \StructType\EstablishmentUpdatedOn, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EstablishmentUpdatedOn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EstablishmentUpdatedOn[] $establishmentUpdatedOn
     * @return \ArrayType\ArrayOfEstablishmentUpdatedOn
     */
    public function setEstablishmentUpdatedOn(array $establishmentUpdatedOn = array())
    {
        // validation for constraint: array
        if ('' !== ($establishmentUpdatedOnArrayErrorMessage = self::validateEstablishmentUpdatedOnForArrayConstraintsFromSetEstablishmentUpdatedOn($establishmentUpdatedOn))) {
            throw new \InvalidArgumentException($establishmentUpdatedOnArrayErrorMessage, __LINE__);
        }
        if (is_null($establishmentUpdatedOn) || (is_array($establishmentUpdatedOn) && empty($establishmentUpdatedOn))) {
            unset($this->EstablishmentUpdatedOn);
        } else {
            $this->EstablishmentUpdatedOn = $establishmentUpdatedOn;
        }
        return $this;
    }
    /**
     * Add item to EstablishmentUpdatedOn value
     * @throws \InvalidArgumentException
     * @param \StructType\EstablishmentUpdatedOn $item
     * @return \ArrayType\ArrayOfEstablishmentUpdatedOn
     */
    public function addToEstablishmentUpdatedOn(\StructType\EstablishmentUpdatedOn $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EstablishmentUpdatedOn) {
            throw new \InvalidArgumentException(sprintf('The EstablishmentUpdatedOn property can only contain items of type \StructType\EstablishmentUpdatedOn, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EstablishmentUpdatedOn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EstablishmentUpdatedOn|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EstablishmentUpdatedOn|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EstablishmentUpdatedOn|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EstablishmentUpdatedOn|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EstablishmentUpdatedOn|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EstablishmentUpdatedOn
     */
    public function getAttributeName()
    {
        return 'EstablishmentUpdatedOn';
    }
}
