<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProductUpdatedOn ArrayType
 * @subpackage Arrays
 */
class ArrayOfProductUpdatedOn extends AbstractStructArrayBase
{
    /**
     * The ProductUpdatedOn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProductUpdatedOn[]
     */
    public $ProductUpdatedOn;
    /**
     * Constructor method for ArrayOfProductUpdatedOn
     * @uses ArrayOfProductUpdatedOn::setProductUpdatedOn()
     * @param \StructType\ProductUpdatedOn[] $productUpdatedOn
     */
    public function __construct(array $productUpdatedOn = array())
    {
        $this
            ->setProductUpdatedOn($productUpdatedOn);
    }
    /**
     * Get ProductUpdatedOn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProductUpdatedOn[]|null
     */
    public function getProductUpdatedOn()
    {
        return isset($this->ProductUpdatedOn) ? $this->ProductUpdatedOn : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProductUpdatedOn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProductUpdatedOn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProductUpdatedOnForArrayConstraintsFromSetProductUpdatedOn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProductUpdatedOnProductUpdatedOnItem) {
            // validation for constraint: itemType
            if (!$arrayOfProductUpdatedOnProductUpdatedOnItem instanceof \StructType\ProductUpdatedOn) {
                $invalidValues[] = is_object($arrayOfProductUpdatedOnProductUpdatedOnItem) ? get_class($arrayOfProductUpdatedOnProductUpdatedOnItem) : sprintf('%s(%s)', gettype($arrayOfProductUpdatedOnProductUpdatedOnItem), var_export($arrayOfProductUpdatedOnProductUpdatedOnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProductUpdatedOn property can only contain items of type \StructType\ProductUpdatedOn, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProductUpdatedOn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProductUpdatedOn[] $productUpdatedOn
     * @return \ArrayType\ArrayOfProductUpdatedOn
     */
    public function setProductUpdatedOn(array $productUpdatedOn = array())
    {
        // validation for constraint: array
        if ('' !== ($productUpdatedOnArrayErrorMessage = self::validateProductUpdatedOnForArrayConstraintsFromSetProductUpdatedOn($productUpdatedOn))) {
            throw new \InvalidArgumentException($productUpdatedOnArrayErrorMessage, __LINE__);
        }
        if (is_null($productUpdatedOn) || (is_array($productUpdatedOn) && empty($productUpdatedOn))) {
            unset($this->ProductUpdatedOn);
        } else {
            $this->ProductUpdatedOn = $productUpdatedOn;
        }
        return $this;
    }
    /**
     * Add item to ProductUpdatedOn value
     * @throws \InvalidArgumentException
     * @param \StructType\ProductUpdatedOn $item
     * @return \ArrayType\ArrayOfProductUpdatedOn
     */
    public function addToProductUpdatedOn(\StructType\ProductUpdatedOn $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProductUpdatedOn) {
            throw new \InvalidArgumentException(sprintf('The ProductUpdatedOn property can only contain items of type \StructType\ProductUpdatedOn, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProductUpdatedOn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProductUpdatedOn|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProductUpdatedOn|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProductUpdatedOn|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProductUpdatedOn|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProductUpdatedOn|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProductUpdatedOn
     */
    public function getAttributeName()
    {
        return 'ProductUpdatedOn';
    }
}
