<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InjectedOfferInfo StructType
 * @subpackage Structs
 */
class InjectedOfferInfo extends AbstractStructBase
{
    /**
     * The GeneralOS
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\GeneralOfferInformation
     */
    public $GeneralOS;
    /**
     * The EstablishmentAffectationList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfEstablishmentInformation
     */
    public $EstablishmentAffectationList;
    /**
     * The MyFilterGeoLocalisation
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Filter
     */
    public $MyFilterGeoLocalisation;
    /**
     * The Periods
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfPeriode
     */
    public $Periods;
    /**
     * Constructor method for InjectedOfferInfo
     * @uses InjectedOfferInfo::setGeneralOS()
     * @uses InjectedOfferInfo::setEstablishmentAffectationList()
     * @uses InjectedOfferInfo::setMyFilterGeoLocalisation()
     * @uses InjectedOfferInfo::setPeriods()
     * @param \StructType\GeneralOfferInformation $generalOS
     * @param \ArrayType\ArrayOfEstablishmentInformation $establishmentAffectationList
     * @param \StructType\Filter $myFilterGeoLocalisation
     * @param \ArrayType\ArrayOfPeriode $periods
     */
    public function __construct(\StructType\GeneralOfferInformation $generalOS = null, \ArrayType\ArrayOfEstablishmentInformation $establishmentAffectationList = null, \StructType\Filter $myFilterGeoLocalisation = null, \ArrayType\ArrayOfPeriode $periods = null)
    {
        $this
            ->setGeneralOS($generalOS)
            ->setEstablishmentAffectationList($establishmentAffectationList)
            ->setMyFilterGeoLocalisation($myFilterGeoLocalisation)
            ->setPeriods($periods);
    }
    /**
     * Get GeneralOS value
     * @return \StructType\GeneralOfferInformation|null
     */
    public function getGeneralOS()
    {
        return $this->GeneralOS;
    }
    /**
     * Set GeneralOS value
     * @param \StructType\GeneralOfferInformation $generalOS
     * @return \StructType\InjectedOfferInfo
     */
    public function setGeneralOS(\StructType\GeneralOfferInformation $generalOS = null)
    {
        $this->GeneralOS = $generalOS;
        return $this;
    }
    /**
     * Get EstablishmentAffectationList value
     * @return \ArrayType\ArrayOfEstablishmentInformation|null
     */
    public function getEstablishmentAffectationList()
    {
        return $this->EstablishmentAffectationList;
    }
    /**
     * Set EstablishmentAffectationList value
     * @param \ArrayType\ArrayOfEstablishmentInformation $establishmentAffectationList
     * @return \StructType\InjectedOfferInfo
     */
    public function setEstablishmentAffectationList(\ArrayType\ArrayOfEstablishmentInformation $establishmentAffectationList = null)
    {
        $this->EstablishmentAffectationList = $establishmentAffectationList;
        return $this;
    }
    /**
     * Get MyFilterGeoLocalisation value
     * @return \StructType\Filter|null
     */
    public function getMyFilterGeoLocalisation()
    {
        return $this->MyFilterGeoLocalisation;
    }
    /**
     * Set MyFilterGeoLocalisation value
     * @param \StructType\Filter $myFilterGeoLocalisation
     * @return \StructType\InjectedOfferInfo
     */
    public function setMyFilterGeoLocalisation(\StructType\Filter $myFilterGeoLocalisation = null)
    {
        $this->MyFilterGeoLocalisation = $myFilterGeoLocalisation;
        return $this;
    }
    /**
     * Get Periods value
     * @return \ArrayType\ArrayOfPeriode|null
     */
    public function getPeriods()
    {
        return $this->Periods;
    }
    /**
     * Set Periods value
     * @param \ArrayType\ArrayOfPeriode $periods
     * @return \StructType\InjectedOfferInfo
     */
    public function setPeriods(\ArrayType\ArrayOfPeriode $periods = null)
    {
        $this->Periods = $periods;
        return $this;
    }
}
