<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for textPhotoInfo StructType
 * @subpackage Structs
 */
class TextPhotoInfo extends AbstractStructBase
{
    /**
     * The myTitle
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $myTitle;
    /**
     * The myLegend
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $myLegend;
    /**
     * The myContent
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $myContent;
    /**
     * The myPhoto
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PhotoInfo
     */
    public $myPhoto;
    /**
     * Constructor method for textPhotoInfo
     * @uses TextPhotoInfo::setMyTitle()
     * @uses TextPhotoInfo::setMyLegend()
     * @uses TextPhotoInfo::setMyContent()
     * @uses TextPhotoInfo::setMyPhoto()
     * @param string $myTitle
     * @param string $myLegend
     * @param string $myContent
     * @param \StructType\PhotoInfo $myPhoto
     */
    public function __construct($myTitle = null, $myLegend = null, $myContent = null, \StructType\PhotoInfo $myPhoto = null)
    {
        $this
            ->setMyTitle($myTitle)
            ->setMyLegend($myLegend)
            ->setMyContent($myContent)
            ->setMyPhoto($myPhoto);
    }
    /**
     * Get myTitle value
     * @return string|null
     */
    public function getMyTitle()
    {
        return $this->myTitle;
    }
    /**
     * Set myTitle value
     * @param string $myTitle
     * @return \StructType\TextPhotoInfo
     */
    public function setMyTitle($myTitle = null)
    {
        // validation for constraint: string
        if (!is_null($myTitle) && !is_string($myTitle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($myTitle, true), gettype($myTitle)), __LINE__);
        }
        $this->myTitle = $myTitle;
        return $this;
    }
    /**
     * Get myLegend value
     * @return string|null
     */
    public function getMyLegend()
    {
        return $this->myLegend;
    }
    /**
     * Set myLegend value
     * @param string $myLegend
     * @return \StructType\TextPhotoInfo
     */
    public function setMyLegend($myLegend = null)
    {
        // validation for constraint: string
        if (!is_null($myLegend) && !is_string($myLegend)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($myLegend, true), gettype($myLegend)), __LINE__);
        }
        $this->myLegend = $myLegend;
        return $this;
    }
    /**
     * Get myContent value
     * @return string|null
     */
    public function getMyContent()
    {
        return $this->myContent;
    }
    /**
     * Set myContent value
     * @param string $myContent
     * @return \StructType\TextPhotoInfo
     */
    public function setMyContent($myContent = null)
    {
        // validation for constraint: string
        if (!is_null($myContent) && !is_string($myContent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($myContent, true), gettype($myContent)), __LINE__);
        }
        $this->myContent = $myContent;
        return $this;
    }
    /**
     * Get myPhoto value
     * @return \StructType\PhotoInfo|null
     */
    public function getMyPhoto()
    {
        return $this->myPhoto;
    }
    /**
     * Set myPhoto value
     * @param \StructType\PhotoInfo $myPhoto
     * @return \StructType\TextPhotoInfo
     */
    public function setMyPhoto(\StructType\PhotoInfo $myPhoto = null)
    {
        $this->myPhoto = $myPhoto;
        return $this;
    }
}
